#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2100three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2100three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three21004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three21004xi = {
                1:'0x2038y-504z',
                2:'0x41y-2099z',
                3:'1023x1413y-1167z',
                4:'1039x1800y-298z',
                5:'1043x1548y-960z',
                6:'1044x1672y-722z',
                7:'106x2040y-484z',
                8:'108x85y-2095z',
                9:'1103x1367y-1150z',
                10:'1128x1499y-941z',
                11:'1133x1745y-278z',
                12:'1135x1621y-702z',
                13:'116x564y-2019z',
                14:'1181x1316y-1132z',
                15:'120x220y-2084z',
                16:'1211x1445y-922z',
                17:'1222x1564y-682z',
                18:'1225x1686y-257z',
                19:'122x1758y-1141z',
                20:'1256x1260y-1114z',
                21:'1292x1387y-903z',
                22:'129x92y-2093z',
                23:'1307x1503y-662z',
                24:'1313x1621y-236z',
                25:'1328x1200y-1096z',
                26:'1369x1323y-884z',
                27:'1388x1438y-642z',
                28:'1397x1552y-215z',
                29:'1398x1136y-1078z',
                30:'13x103y-2097z',
                31:'142x231y-2082z',
                32:'1443x1256y-865z',
                33:'1464x1067y-1060z',
                34:'1466x1367y-622z',
                35:'1478x1478y-194z',
                36:'1513x1184y-846z',
                37:'151x577y-2013z',
                38:'1541x1293y-602z',
                39:'1555x1400y-173z',
                40:'1580x1107y-827z',
                41:'1611x1214y-582z',
                42:'1627x1318y-152z',
                43:'165x1891y-896z',
                44:'166x240y-2079z',
                45:'1677x1131y-562z',
                46:'1695x1231y-131z',
                47:'174x1688y-1399z',
                48:'187x587y-2007z',
                49:'191x248y-2076z',
                50:'1x62y-2099z',
                51:'20x26y-2099z',
                52:'214x2036y-464z',
                53:'215x1760y-1124z',
                54:'217x253y-2073z',
                55:'224x595y-2001z',
                56:'23x123y-2096z',
                57:'244x256y-2069z',
                58:'24x514y-2035z',
                59:'252x1613y-1319z',
                60:'263x601y-1994z',
                61:'265x1889y-877z',
                62:'273x257y-2066z',
                63:'29x1750y-1159z',
                64:'301x256y-2062z',
                65:'303x604y-1988z',
                66:'309x1758y-1106z',
                67:'321x2027y-443z',
                68:'331x252y-2058z',
                69:'339x1611y-1303z',
                70:'344x605y-1981z',
                71:'34x142y-2094z',
                72:'34x42y-2099z',
                73:'361x246y-2053z',
                74:'365x1881y-858z',
                75:'386x602y-1974z',
                76:'403x1750y-1088z',
                77:'426x1603y-1286z',
                78:'427x2012y-422z',
                79:'429x597y-1966z',
                80:'465x1867y-839z',
                81:'472x589y-1959z',
                82:'47x160y-2093z',
                83:'497x1737y-1070z',
                84:'514x1591y-1270z',
                85:'515x578y-1951z',
                86:'51x55y-2098z',
                87:'52x533y-2030z',
                88:'533x1990y-402z',
                89:'558x565y-1943z',
                90:'565x1848y-819z',
                91:'590x1718y-1052z',
                92:'601x1573y-1253z',
                93:'601x548y-1935z',
                94:'638x1963y-381z',
                95:'63x177y-2091z',
                96:'644x528y-1927z',
                97:'65x1888y-915z',
                98:'664x1824y-800z',
                99:'683x1695y-1033z',
                100:'686x505y-1919z',
                101:'687x1551y-1236z',
                102:'68x67y-2097z',
                103:'6x10y-2099z',
                104:'6x83y-2098z',
                105:'728x478y-1910z',
                106:'741x1931y-361z',
                107:'761x1794y-780z',
                108:'773x1524y-1219z',
                109:'775x1666y-1015z',
                110:'80x193y-2089z',
                111:'83x549y-2025z',
                112:'842x1893y-340z',
                113:'857x1759y-761z',
                114:'858x1492y-1202z',
                115:'866x1632y-997z',
                116:'88x77y-2096z',
                117:'941x1455y-1185z',
                118:'942x1849y-319z',
                119:'952x1718y-741z',
                120:'956x1593y-978z',
                121:'99x207y-2087z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2100three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2100three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2100THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2100THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2100THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2100THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2100THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three21004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2100THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2100THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2100THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three21004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three21004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2100THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2100THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2100THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2100three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                